#include <cstdlib>
#include <iostream>

#include "sadacount.h"

//--------------------------------------------------------------------------

int
main(int argc, char** argv)
{
  std::cout << "Building Sadakane's document counting structure" << std::endl;
  if(argc < 2)
  {
    std::cout << "Usage: build_sadacount base_name [mode]" << std::endl;
    std::cout << "  s  Standard SadaCount (default)" << std::endl;
    std::cout << "  e  SadaCount for export (uses more space, includes standard)" << std::endl;
    std::cout << "  f  Use a filter" << std::endl;
    std::cout << "  o  Original SadaCount" << std::endl;
    std::cout << std::endl;
    return 1;
  }

  std::string base_name = argv[1];
  std::cout << "Base name: " << base_name << std::endl;
  sc_mode_type mode = sc_standard;
  if(argc > 2)
  {
    switch(argv[2][0])
    {
      case 's': mode = sc_standard; break;
      case 'e': mode = sc_export; break;
      case 'f': mode = sc_filter; break;
      case 'o': mode = sc_original; break;
      default:
        std::cerr << "build_sadacount: Invalid mode: " << argv[2] << std::endl;
        return 2;
    }
  }
  std::cout << "Mode: ";
  switch(mode)
  {
    case sc_standard: std::cout << "standard"; break;
    case sc_export: std::cout << "export"; break;
    case sc_filter: std::cout << "filter"; break;
    case sc_original: std::cout << "original"; break;
  }
  std::cout << std::endl << std::endl;

  buildSadaCount(base_name, mode, true);

  return 0;
}
